<?xml version="1.0"?>
<!-- 
(c)2005 David Sporn

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License version 2.1 as published by the Free Software Foundation.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>
<!-- Main part -->
<xsl:template match="bean"><![CDATA[<?php 
/****** GENERATED CODE - DO NOT EDIT ******/
]]><xsl:if test="string-length(@extends)>0"><xsl:value-of select="concat('require_once(&quot;', @extends, '.php&quot;); ')"/></xsl:if><![CDATA[

/**]]><xsl:value-of select="description"/><![CDATA[.
 *
 * This object contains the following properties (name, description) :]]><xsl:apply-templates select="property" mode="varDocumentation"/><![CDATA[
 */
class ]]><xsl:value-of select="@classname"/><xsl:if test="string-length(@extends)>0"><xsl:value-of select="concat(' extends ', @extends, ' ')"/></xsl:if><![CDATA[
{
	//==========
	//Copy functions
	
	/**Copy fields data from a source object.
	 * @param source object source, it must have the proper accessors.
	 */
	function copyFrom($source)
	{]]><xsl:apply-templates select="property" mode="copyFrom"/><![CDATA[
	}

	/**Copy fields data to a target object.
	 * @param target object to fill, it must have the proper accessors.
	 */
	function copyTo($target)
	{]]><xsl:apply-templates select="property" mode="copyTo"/><![CDATA[
	}

	//==========
	//Accessors]]><xsl:apply-templates select="property" mode="getter"/><![CDATA[

	//==========
	//Fields]]><xsl:apply-templates select="property" mode="varDeclaration"/><![CDATA[
}


?>]]>
</xsl:template>

<!-- Property documentation -->
<xsl:template match="property" mode="varDocumentation"><![CDATA[
 * ]]><xsl:value-of select="@name"/><![CDATA[, ]]><xsl:value-of select="description"/><![CDATA[
]]></xsl:template>

<!-- copyFrom -->
<xsl:template match="property" mode="copyFrom"><![CDATA[
	$this->set]]><xsl:value-of select="@name"/><![CDATA[($source->get]]><xsl:value-of select="@name"/><![CDATA[()) ;
]]></xsl:template>

<!-- copyTo -->
<xsl:template match="property" mode="copyTo"><![CDATA[
	$target->set]]><xsl:value-of select="@name"/><![CDATA[($this->get]]><xsl:value-of select="@name"/><![CDATA[()) ;
]]></xsl:template>

<!-- Property declaration -->
<xsl:template match="property" mode="varDeclaration"><![CDATA[
	/**]]><xsl:value-of select="description"/><![CDATA[.*/
	private $my]]><xsl:value-of select="@name"/><![CDATA[ ;
]]></xsl:template>

<!-- Property accessors (default, then specific type value) -->
<xsl:template match="property" mode="getter"><![CDATA[
	/* ----=]]><xsl:value-of select="description"/><![CDATA[=---- */

	/**Reads ]]><xsl:value-of select="@name"/><![CDATA[.
	 */
	function get]]><xsl:value-of select="@name"/><![CDATA[()
	{
		return $this->my]]><xsl:value-of select="@name"/><![CDATA[ ;
	}

	/**Changes ]]><xsl:value-of select="@name"/><![CDATA[.
	 */
	function set]]><xsl:value-of select="@name"/><![CDATA[($a]]><xsl:value-of select="@name"/><![CDATA[)
	{
		$this->my]]><xsl:value-of select="@name"/><![CDATA[ = $a]]><xsl:value-of select="@name"/><![CDATA[ ;
	}
]]></xsl:template>

</xsl:stylesheet>